;--------------------------------------------------------
; ISO9660 CD-ROM Monitor
; Copyright (C) by Josef Soucek (josef.soucek@spt.cz) 
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
; Revision History:
;
; 99/11/18   First release
;
;--------------------------------------

                   *= $b0
par1                      *=*+1
par2                      *=*+1
par3                      *=*+1
par4                      *=*+1
prn1                      *=*+1
prn2                      *=*+1

                   *= $2000
info_buffer               *=*+1
info_M                    *=*+1
info_S                    *=*+1
info_F                    *=*+1
root_M                    *=*+1   ;Umisteni ROOTu
root_S                    *=*+1
root_F                    *=*+1
root_size0                *=*+1
root_size1                *=*+1
root_size2                *=*+1
back_M                    *=*+1   ;Temporary
back_S                    *=*+1
back_F                    *=*+1
back_size0                *=*+1
back_size1                *=*+1
back_size2                *=*+1


                   *= $3000
data_buffer                =*

subchnl_buffer            *=*+1
subchnl_audio_status      *=*+5
subchnl_track_number      *=*+3
subchnl_minute            *=*+1
subchnl_second            *=*+1
subchnl_frame             *=*+1

play_in_progress          = $11
play_paused               = $12
play_completed            = $13
no_audio_status           = $15

                   *= $4000
prompt_buffer              =*

getin                   = $ffe4
chrin                   = $ffcf
setnam                  = $ffbd
setlfs                  = $ffba
plot                    = $fff0
open                    = $ffc0
chkout                  = $ffc9
; chrout                  = $ffd2
close                   = $ffc3
clall                   = $ffe7
print_num               = $bdcd
print_ascii             = $ab1e
keyb_stat               = $028a

;--------------------------------------

                   *= $c000
main_start         = *
                   lda #<monitor_head
                   ldy #>monitor_head
                   jsr print_ascii

                   lda #<monitor_commands
                   ldy #>monitor_commands
                   jsr print_ascii

                   lda keyb_stat
                   sta keyboard_rep
                   lda #0
                   sta keyb_stat
                   
                   lda #1                    ;Slave
                   jsr ioctl_SELECTDRIVE
                   jsr ioctl_IDENTIFYDRIVE
                   jsr ioctl_ANALYZECDROM
                   
main_loop          = *
                   jsr getin
                   cmp #0
                   bne main_loop                   

get_key_loop       = *
                   jsr getin
                   cmp #"R"
                   beq cdrom_read
                   cmp #"E"
                   beq player_eject
                   cmp #"C"
                   beq player_closetray
                   cmp #"T"
                   bne get_key_ov2
                   jmp test_command
get_key_ov2        = *
                   cmp #"Q"
                   bne get_key_loop
                   lda keyboard_rep     ;Player quit
                   sta keyb_stat
                   rts
;------------------
player_eject       = *
                   jsr ioctl_CDROMSTOP
                   jsr ioctl_CDROMUNLOCK        ;Pro jistotu
                   jsr ioctl_CDROMEJECT
                   jmp main_loop
player_closetray   = *
                   jsr ioctl_CDROMCLOSETRAY
                   jsr ioctl_CDROMRESET         ;!!!
                   jmp main_loop
;--------------------------------------
cdrom_read         = *
                   lda #0
                   sta info_M
                   lda #0
                   sta info_S
                   lda #16
                   sta info_F

                   jsr read_data_sector
                   
                   lda #>data_buffer
                   jsr print_ISO9660_info
                   bcs cdrom_read_exit
                   
                   lda #>data_buffer
                   jsr set_root_dir

                   lda root_M
                   sta info_M
                   lda root_S
                   sta info_S
                   lda root_F
                   sta info_F
                   lda root_size0
                   sta current_size0
                   lda root_size1
                   sta current_size1
                   lda root_size2
                   sta current_size2

cdrom_read_loop    = *
                   jsr read_data_sector
                   jsr store_akt_sector
                   jsr print_iso9660_dir
             
                   jsr get_number               ;prompt_num0/1
                   bcc cdrom_read_cont
                   jmp main_start 
cdrom_read_cont    = *
                   jsr get_akt_sector
                   jsr read_data_sector
                   jsr get_iso9660_dir
                   
                   lda current_flag
                   lsr                 ;1=hidden
                   lsr                 ;1=directory
                   bcs cdrom_read_loop

                   jsr copy_file
                   
                   jsr get_akt_sector

                   jmp cdrom_read_loop

cdrom_read_exit    = *
                   jmp main_loop
;--------------------------------------
get_akt_sector     = *
;                    lda back_size2
;                    sta current_size2
                   lda back_size1
                   sta current_size1
                   lda back_size0
                   sta current_size0
                   lda back_F
                   sta info_F
                   lda back_S
                   sta info_S
                   lda back_M
                   sta info_M
                   rts
;--------------------------------------
store_akt_sector   = *
                   lda info_M
                   sta back_M
                   lda info_S
                   sta back_S
                   lda info_F
                   sta back_F
                   lda current_size0
                   sta back_size0
                   lda current_size1
                   sta back_size1
;                    lda current_size2
;                    sta back_size2
                   rts
;--------------------------------------
read_data_sector   = *
;                    lda #<sector_info
;                    ldy #>sector_info
;                    jsr print_ascii
; 
;                    lda info_M
;                    jsr print_hex
;                    lda info_S
;                    jsr print_hex
;                    lda info_F
;                    jsr print_hex
;                    lda #$0d
;                    jsr chrout

                   sei                          ;Patch ###
                   ldx #>info_buffer
                   lda #>data_buffer
                   jsr ioctl_CDROMREADDATA
                   cli                          ;#########
                   rts
                   ;
; sector_info        .text $0d,"SECTOR: ",$00
;--------------------------------------
set_root_dir       = *
                   sta par2
                   lda #$9c                     ;offset $09c
                   sta par1
                   
                   ldy #2
                   lda (par1),y
                   sta root_F
                   iny
                   lda (par1),y
                   sta root_S
                   iny
                   lda (par1),y
                   sta root_M
                   
                   ldy #$0a
                   lda (par1),y
                   sta root_size0
                   iny
                   lda (par1),y
                   sta root_size1
                   iny
                   lda (par1),y
                   sta root_size2
                   rts
;--------------------------------------
test_command       = *
;                   lda #$00     ;Min
;                   sta info_M
;                   lda #$00     ;Sec
;                   sta info_S
;                   lda #$16     ;Frame
;                   sta info_F
                    
                   jsr read_data_sector
                    
                   lda #>data_buffer
                   jsr print_sector
                    
;                   jsr ioctl_ANALYZECDROM
 
                   jmp main_loop
;--------------------------------------
print_sector       = *
                   sta par2
                   lda #0
                   sta par1
                   
                   lda #<$0400
                   sta par3
                   lda #>$0400
                   sta par4
                   
                   ldx #3
                   ldy #0
print_sector_loop  = *
                   lda (par1),y
                   sta (par3),y
                   iny
                   bne print_sector_loop
                   inc par2
                   inc par4
                   dex
                   bne print_sector_loop
                   rts
;--------------------------------------
print_ISO9660_info = *
                   sta par2
                   lda #0
                   sta par1

                   ldy #$ff
iso9660_loop       = *
                   iny
                   lda ISO9660_ID,y
                   beq iso9660_detected
                   cmp (par1),y
                   beq iso9660_loop
                   sec
                   rts                          ;Exit - ISO9660 not found

iso9660_detected   = *
                   lda #<format_ISO9660_info
                   ldy #>format_ISO9660_info
                   jsr print_ascii

                   lda #<system_id_info
                   ldy #>system_id_info
                   jsr print_ascii

                   lda par1
                   sta prn1
                   lda par2
                   sta prn2

                   lda #$08
                   ldy #$00
                   ldx #32
                   jsr print_string2

                   lda #<volume_id_info
                   ldy #>volume_id_info
                   jsr print_ascii

                   lda #$28
                   ldy #$00
                   ldx #32
                   jsr print_string2

                   lda #<creating_date_info
                   ldy #>creating_date_info
                   jsr print_ascii

                   lda #$2d
                   ldy #$03
                   ldx #17
                   jsr print_string2
                   clc
                   rts
                   ;
format_ISO9660_info = *
                   .text $0d,"FORMAT ISO9660",$0d,$00
system_id_info     .text $0d,"SYSTEM ID: ",$00
volume_id_info     .text $0d,"VOLUME ID: ",$00
creating_date_info .text $0d,"CREATING DATE: ",$00
ISO9660_ID         .text $01,"CD001",$01,$00
;--------------------------------------
print_iso9660_dir  = *

                   lda #0               ;##
                   sta file_offset0     ;##
                   sta file_offset1     ;##

                   lda #$0d
                   jsr chrout

print_iso9660_dir_new_sector = *
                   lda #>data_buffer
                   sta par2
                   lda #0
                   sta par1
     
print_iso9660_dir_loop = *

                   ldy #0
                   lda (par1),y
                   bne print_iso_over
                   jmp print_iso9660_dir_last
print_iso_over     = *
                   sta delka_recordu
                   
                   ldx file_offset0    ;## 
                   lda file_offset1    ;##
                   jsr print_num       ;##
                   lda #" "            ;##
                   jsr chrout          ;##

                   ldy #$19            ;Flags
                   lda (par1),y
                   lsr                 ;1=hidden
                   lsr                 ;1=directory
                   bcc print_iso9660_dir_select

                   lda #"D"
                   .byte $2c
print_iso9660_dir_select = *
                   lda #"-"
                   jsr chrout
                   lda #" "
                   jsr chrout

                   ldy #$20
                   lda (par1),y
                   tax
                   cpx #$01
                   bne print_iso9660_dir_name

                   ldy #$21                  ;Filename
                   lda (par1),y
                   beq print_iso9660_dir_first
                   cmp #$01
                   bne print_iso9660_dir_name

                   lda #"."
                   jsr chrout
print_iso9660_dir_first = *
                   lda #"."
                   jsr chrout
                   jmp print_iso9660_dir_noname
                   
print_iso9660_dir_name = *
                   dex
                   dex
                   txa
                   clc
                   adc #$21
                   tay
                   lda (par1),y
                   cmp #";"                  ;Netiskne ";1"
                   beq print_iso9660_dir_name2
                   
                   inx
                   inx
print_iso9660_dir_name2 = *

                   lda par1
                   sta prn1
                   lda par2
                   sta prn2

                   lda #$21
                   ldy #$00
                   jsr print_string2   ;Print Filename
print_iso9660_dir_noname = *
                   lda #" "
                   jsr chrout
                   lda #" "
                   jsr chrout
                   
                   ldy #$0a            ;filesize
                   lda (par1),y
                   sta opa0
                   iny
                   lda (par1),y
                   sta opa1
                   iny
                   lda (par1),y
                   sta opa2
                   jsr asciinum

                   lda #$0d
                   jsr chrout
                
                   ;############## Test STOP
                   lda $91
                   cmp #$7f
                   beq stop_pressed
                   ;##############

                   clc
                   lda par1
                   adc delka_recordu
                   sta par1
                   lda par2
                   adc #0
                   sta par2
                   inc file_offset0           ;##
                   bne print_iso9660_dir_cont
                   inc file_offset1           ;##
print_iso9660_dir_cont = *
                   jmp print_iso9660_dir_loop
                   
print_iso9660_dir_last = *
                   jsr dec_dir_size
                   bcc print_iso9660_dir_exit  ;if Mensi nez 2048

                   jsr info_sector_inc
                   jsr read_data_sector
                   
                   jmp print_iso9660_dir_new_sector

print_iso9660_dir_exit = *
                   rts
stop_pressed       = *
                   lda #<stopped_info
                   ldy #>stopped_info
                   jsr print_ascii
                   rts
                   ;
stopped_info       .text $0d,"STOPPED",$0d,$00
;--------------------------------------
dec_dir_size       = *
                   sec
                   lda current_size0
                   sbc #$00
                   sta current_size0
                   lda current_size1
                   sbc #$08            ;2048
                   sta current_size1
;                    lda current_size2
;                    sbc #$00
;                    sta current_size2
                   
                   lda current_size0   ;cmp 2048
                   cmp #$00
                   lda current_size1
                   sbc #$08
                   rts

;--------------------------------------
; Input: prompt_num0/1
;--------------------------------------
get_iso9660_dir    = *
                   lda #0
                   sta file_offset0
                   sta file_offset1

get_iso9660_dir_new_sector = *
                   
                   lda #>data_buffer
                   sta par2
                   lda #0
                   sta par1
     
get_iso9660_dir_loop = *

                   ldy #0
                   lda (par1),y
                   bne get_iso_over
                   
                   jsr dec_dir_size
                   bcc get_iso9660_dir_exit  ;if Mensi nez 2048

                   jsr info_sector_inc
                   jsr read_data_sector
                   
                   jmp get_iso9660_dir_new_sector
                   
get_iso_over       = *
                   sta delka_recordu
                   
                   lda file_offset0
                   cmp prompt_num0
                   bne get_iso9660_dir_next
                   lda file_offset1
                   cmp prompt_num1
                   beq get_iso9660_dir_found
                 
get_iso9660_dir_next = *
                   clc
                   lda par1
                   adc delka_recordu
                   sta par1
                   lda par2
                   adc #0
                   sta par2
                   inc file_offset0
                   bne get_iso9660_dir_cont
                   inc file_offset1
get_iso9660_dir_cont = *
                   jmp get_iso9660_dir_loop

get_iso9660_dir_found = *
                   ldy #$02
                   lda (par1),y
                   sta info_F
                   iny
                   lda (par1),y
                   sta info_S
                   iny
                   lda (par1),y
                   sta info_M
                   
                   ldy #$19
                   lda (par1),y
                   sta current_flag

                   ldy #$0a
                   lda (par1),y
                   sta current_size0
                   iny
                   lda (par1),y
                   sta current_size1
                   iny
                   lda (par1),y
                   sta current_size2
                   
                   ldy #$20
                   lda (par1),y
                   sta current_namesize

                   clc
                   lda par1
                   adc #$21
                   sta current_name0
                   lda par2
                   adc #$00
                   sta current_name1
                   
get_iso9660_dir_exit = *
                   rts
;--------------------------------------
; A-lo,Y-hi offset
; X - delka
;--------------------------------------
print_string2      = *
                   sta pom_a
                   sty pom_y
                   lda prn1
                   pha
                   lda prn2
                   pha 
                   
                   clc   
                   lda pom_a
                   adc prn1
                   sta prn1
                   lda pom_y
                   adc prn2
                   sta prn2

                   ldy #0
print_string2_loop = *
                   lda (prn1),y
                   jsr chrout
                   iny
                   dex
                   bne print_string2_loop
                   
                   pla
                   sta prn2
                   pla
                   sta prn1
                   rts
;--------------------------------------
get_number         = *
                   lda #<prompt_info
                   ldy #>prompt_info
                   jsr print_ascii
                   
                   lda #0
                   sta prompt_num1

                   ldy #0
get_number_loop    = *
                   jsr chrin
                   sta prompt_buffer,y
                   iny
                   cmp #$0d
                   bne get_number_loop
                   cpy #1                    ;Prazdny radek
                   beq get_number
                   dey
                   dey
                   
                   lda prompt_buffer,y
                   cmp #"Q"
                   beq get_number_exit1
                   sec
                   sbc #$30
                   sta prompt_num0
                   cpy #0
                   beq get_number_exit

                   dey
                   sec
                   lda prompt_buffer,y
                   sbc #$30
                   sta prompt_pom
                   asl
                   asl
                   asl
                   clc
                   adc prompt_pom
                   adc prompt_pom
                   adc prompt_num0
                   sta prompt_num0
                   
                   cpy #0
                   beq get_number_exit
                   dey
                   sec
                   lda prompt_buffer,y
                   sbc #$30
                   beq get_number_exit
                   sta prompt_pom
get_number_100     = *
                   clc
                   lda prompt_num0
                   adc #100
                   sta prompt_num0
                   lda prompt_num1
                   adc #$00
                   sta prompt_num1
                   dec prompt_pom
                   bne get_number_100

get_number_exit    = *
;                   ldx prompt_num0
;                   lda prompt_num1
;                   jsr print_num

                   clc
                   rts
get_number_exit1   = *
                   sec
                   rts
                   ;
prompt_info        .text $0d,"FILE/DIR # (Q=EXIT)> ",$00
;--------------------------------------
; Input: info_M/S/F; current_size0/1/2  
;        current_record0/1, current_filename
;
;--------------------------------------
copy_file          = *
                   lda #<confirm_info
                   ldy #>confirm_info
                   jsr print_ascii
                   
copy_file_getin    = *
                   jsr getin
                   beq copy_file_getin
                   cmp #"Y"
                   bne get_number_exit
                   
                   ldx current_name0
                   ldy current_name1
                   lda current_namesize
                   jsr setnam
                   tay
                   dey
                   dey
                   lda ($bb),y
                   cmp #";"
                   bne copy_file_name
                   dec $b7
                   dec $b7             ;Odseparuje ";1"
                   
copy_file_name     = * 
                   lda #2
                   ldx #12
                   ldy #1           ;write !!!
                   jsr setlfs     
                  
                   lda #$02
                   jsr open  ;open output file
                  
                   ldx #$02
                   jsr chkout

copy_file_loop     = *
                   sei                    ;Patch ###
                   ldx #>info_buffer
                   lda #>data_buffer
                   jsr ioctl_CDROMREADDATA
                   cli                    ;#########
                   
                   jsr info_sector_inc

                   lda #>data_buffer
                   sta par2
                   lda #0
                   sta par1

copy_file_loop_small = *                   
                   ldy #0
                   lda (par1),y
                   jsr chrout
                   
                   sec
                   lda current_size0
                   sbc #1
                   sta current_size0
                   lda current_size1
                   sbc #0
                   sta current_size1
                   lda current_size2
                   sbc #0
                   sta current_size2
                   
                   lda current_size0  ;if == 0
                   bne copy_file_compare
                   lda current_size1
                   bne copy_file_compare
                   lda current_size2
                   beq copy_file_close

copy_file_compare  = *
                   inc par1
                   bne copy_file_cont
                   inc par2
copy_file_cont     = *
                   lda par1
                   bne copy_file_cont2
                   sec
                   lda par2
                   sbc #>data_buffer
                   cmp #$08               ;$0800 => 2048
                   beq copy_file_loop
copy_file_cont2    = *
                   jmp copy_file_loop_small

copy_file_close    = *
                   lda #2
                   jsr close
                   jsr clall
                   rts
                   ;
confirm_info       .text $0d,"COPY FILE ? Y/N",$00
;--------------------------------------
info_sector_inc    = *
                   inc info_F
                   bne info_sector_inc_cont
                   inc info_S
                   bne info_sector_inc_cont
                   inc info_M
info_sector_inc_cont = *
                   rts
;--------------------------------------
; Tiskne na std. vystup dekadicke cislo
; cislo = opa0 - opa2
; pouziva opb0 ... (4+2 bytes)       
;--------------------------------------
asciinum = *   
         lda #0
         ldx #4    
cl_bcd   = *         
         sta opb0,x
         dex
         bpl cl_bcd   
         
       ; ldy #32 
         ldy #24
         sei
         sed         ;prepne do DEC modu

nextbit = *
        asl opa0
        rol opa1
        rol opa2
        ldx #3
add_bcd = *        
        lda opb0,x
        adc opb0,x
        sta opb0,x
        dex
        bpl add_bcd
        dey
        bne nextbit
        cld
        cli
              
                       
        lda #8
        sta opb0+5           ;priznak
        ldx #0
bcd_byte = *        
        lda opb0,x
        jsr utoaPutHex
        inx
        cpx #4
        bcc bcd_byte  
        
        rts
;-------------- 
utoaPutHex = *
            pha
            lsr
            lsr
            lsr
            lsr              ;horni 1/2 byte
            jsr utoaPutDigit
            pla
            and #$0f         ;spodni 1/2 byte

utoaPutDigit = *
            bne exist_num    ; kdyz je cislo nenulove jde na tisk
            dec opb0+5
            ldy opb0+5
            beq exist_num    ;kdyz priznak je 0  tzn. vytiskne posledni 0
            cpy #8
            bcs exist_num    ;kdyz priznak je => 8 tzn. uz nekdy bylo ne0 cislo
            rts              ; *** nuly na zacatku vynechava ***
exist_num   = *
            ora #$30
            sta opb0+5       ;priznak
            jsr chrout
            rts

;--------------------------------------
monitor_head       = *
                   .byte 142,$0d
                   .text "ucccccccccccccccccccccccccccci",$0d
                   .text "bATAPI CD-ROM ISO9660 MONITORb",$0d
                   .text "b  V0.02 BY VISAC  (C) 1999  b",$0d
                   .text "jcccccccccccccccccccccccccccck",$00
monitor_commands   = *
                   .text $0d,$0d," E - EJECT"
                   .text $0d," C - CLOSE TRAY"
                   .text $0d," R - CDROM READ"
                   .text $0d," T - TEST"
                   .text $0d," Q - QUIT",$0d,$0d
                   .byte 0
                   
keyboard_rep       *=*+1
pom_x              *=*+1
pom_y              *=*+1
pom_a              *=*+1
delka_recordu      *=*+1
file_offset0       *=*+1
file_offset1       *=*+1
prompt_pom         *=*+1
prompt_num0        *=*+1
prompt_num1        *=*+1
current_flag       *=*+1
current_size0      *=*+1
current_size1      *=*+1
current_size2      *=*+1
current_name0      *=*+1
current_name1      *=*+1
current_namesize   *=*+1
;--------------------------------------  ASCIINUM
opa0               *=*+1
opa1               *=*+1
opa2               *=*+1
opb0               *=*+6
;--------------------------------------
                   .include "atapi04.asm"

