;--------------------------------------------------------
; CD Player
; Copyright (C) by Josef Soucek (josef.soucek@spt.cz) 
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
; Revision History:
;
; 99/10/05   First release
;
;--------------------------------------

                   *= $3000

subchnl_buffer            *=*+1
subchnl_audio_status      *=*+5
subchnl_track_number      *=*+3
subchnl_minute            *=*+1
subchnl_second            *=*+1
subchnl_frame             *=*+1

play_in_progress          = $11
play_paused               = $12
play_completed            = $13
no_audio_status           = $15

                   *= $3100

track_buffer              *=*+1
track_minute_start        *=*+1
track_second_start        *=*+1
track_frame_start         *=*+2
track_minute_end          *=*+1
track_second_end          *=*+1
track_frame_end            =*

                   *= $3200

tocall_buffer              =*
tocall_data_hi            *=*+1
tocall_data_low           *=*+1
tocall_FirstTrk           *=*+1
tocall_LastTrk            *=*+1
tocall_data_buffer         =*

getin                   = $ffe4
plot                    = $fff0
print_num               = $bdcd
print_ascii             = $ab1e
keyb_stat               = $028a

;--------------------------------------

                   *= $c000
                   
                   lda #<player_head
                   ldy #>player_head
                   jsr print_ascii
                   sec
                   jsr plot
                   stx x_cursor_tr
                   sty y_cursor_tr

                   lda #<player_commands
                   ldy #>player_commands
                   jsr print_ascii

                   lda keyb_stat
                   sta keyboard_rep
                   lda #0
                   sta keyb_stat
                   
                   lda #1                    ;Slave
                   jsr ioctl_SELECTDRIVE
                   jsr info_track
                   
main_loop          = *
                   jsr getin
                   cmp #0
                   bne main_loop                   

get_key_loop       = *
                   jsr track_timer
                   jsr getin
                   cmp #"P"
                   beq player_play
                   cmp #"S"
                   beq player_stop
                   cmp #"E"
                   beq player_eject
                   cmp #"C"
                   beq player_closetray
                   cmp #"+"
                   beq player_inc
                   cmp #"-"
                   bne get_key_ov1
                   jmp player_dec
get_key_ov1        = *
                   cmp #"T"
                   bne get_key_ov2
                   jmp test_command
get_key_ov2        = *
                   cmp #"Q"
                   bne get_key_loop
                   lda keyboard_rep     ;Player quit
                   sta keyb_stat
                   rts
;------------------
player_play        = *
                   lda #>subchnl_buffer
                   jsr ioctl_CDROMSUBCHNL
                   lda subchnl_audio_status
                   cmp #play_in_progress
                   beq player_pause               
                   cmp #play_paused
                   beq player_resume
                   
                   jsr ioctl_CDROMRESET    ;bez toho VUEGO nesel levy kanal
                   jsr ioctl_CDROMSTART           ;???
                   lda #1
                   jsr print_track
                   jsr ioctl_CDROMPLAYTRKIND
                   jmp main_loop
player_resume      = *
                   jsr ioctl_CDROMRESUME
                   jmp main_loop
player_pause       = *
                   jsr ioctl_CDROMPAUSE
                   jmp main_loop
player_stop        = *
                   jsr ioctl_CDROMSTOP
                   jmp main_loop
player_eject       = *
                   jsr ioctl_CDROMSTOP
                   jsr ioctl_CDROMUNLOCK        ;Pro jistotu
                   jsr ioctl_CDROMEJECT
                   jmp main_loop
player_closetray   = *
                   jsr ioctl_CDROMCLOSETRAY
                   jsr ioctl_CDROMRESET         ;!!!
                   jmp main_loop
;------------------
player_inc         = *
                   lda #>tocall_buffer
                   jsr ioctl_CDROMREADTOC
                   lda #>subchnl_buffer
                   jsr ioctl_CDROMSUBCHNL
                   lda subchnl_audio_status
                   cmp #play_in_progress
                   beq player_inc_in_pr
                   cmp #play_paused
                   beq player_inc_paused
                                                ;Not Playing yet
                   ldy tocall_FirstTrk
                   jsr player_inc_cont
                   jsr ioctl_CDROMPAUSE
                   jmp main_loop
player_inc_paused  = *
                   jsr player_inc_play
                   jsr ioctl_CDROMPAUSE
                   jmp main_loop
player_inc_in_pr   = *
                   jsr player_inc_play
                   jmp main_loop
                   ;
player_inc_play    = *
                   lda subchnl_track_number
                   cmp tocall_LastTrk
                   bcc player_inc_over
                   ldy tocall_FirstTrk
                   jmp player_inc_cont
player_inc_over    = *
                   tay
                   iny
player_inc_cont    = *
                   tya
                   sta track_my
                   jsr print_track
                   
                   jsr set_start_track
                   ldx #>track_buffer
                   jsr ioctl_CDROMPLAYMSF
player_inc_loop    = *
                   lda #>subchnl_buffer
                   jsr ioctl_CDROMSUBCHNL
                   lda subchnl_track_number
                   cmp track_my
                   bne player_inc_loop
                   rts
;------------------
player_dec         = *
                   lda #>tocall_buffer
                   jsr ioctl_CDROMREADTOC
                   lda #>subchnl_buffer
                   jsr ioctl_CDROMSUBCHNL
                   lda subchnl_audio_status
                   cmp #play_in_progress
                   beq player_dec_in_pr
                   cmp #play_paused
                   beq player_dec_paused
                                                ;Not Playing yet
                   ldy tocall_LastTrk
                   jsr player_dec_cont
                   jsr ioctl_CDROMPAUSE
                   jmp main_loop
player_dec_paused  = *
                   jsr player_dec_play
                   jsr ioctl_CDROMPAUSE
                   jmp main_loop
player_dec_in_pr   = *
                   jsr player_dec_play
                   jmp main_loop
                   ;
player_dec_play    = *
                   lda tocall_FirstTrk
                   cmp subchnl_track_number
                   bcc player_dec_over
                   ldy tocall_LastTrk
                   jmp player_dec_cont
player_dec_over    = *
                   ldy subchnl_track_number
                   dey
player_dec_cont    = *
                   tya
                   sta track_my
                   jsr print_track
                   
                   jsr set_start_track
                   ldx #>track_buffer
                   jsr ioctl_CDROMPLAYMSF
player_dec_loop    = *
                   lda #>subchnl_buffer
                   jsr ioctl_CDROMSUBCHNL
                   lda subchnl_track_number
                   cmp track_my
                   bne player_dec_loop
                   rts

;--------------------------------------
set_start_track    = *
                   dey                          ;TrackNum-1
                   tya
                   asl
                   asl
                   asl ;x8
                   clc
                   adc #5  ;Posun na Min
                   tay
                   lda tocall_data_buffer,y
                   sta track_minute_start
                   iny
                   lda toc_data_buffer,y
                   sta track_second_start
                   iny
                   lda toc_data_buffer,y
                   sta track_frame_start

                   ldy tocall_LastTrk
                   tya
                   asl
                   asl
                   asl ;x8
                   clc
                   adc #5                       ;Posun na End_Min
                   tay
                   lda toc_data_buffer,y
                   sta track_minute_end
                   iny
                   lda toc_data_buffer,y
                   sta track_second_end
                   iny
                   lda toc_data_buffer,y
                   sta track_frame_end
                   rts
;--------------------------------------
track_timer        = *
                   inc timer0
                   bne track_timer_end
                   inc timer1
                   bne track_timer_end
info_track         = *
                   lda #200
                   sta timer1
                   
                   lda #>subchnl_buffer
                   jsr ioctl_CDROMSUBCHNL
                   lda subchnl_audio_status
                   cmp #play_in_progress
                   beq track_timer_play
                   cmp #play_paused
                   beq track_timer_paused

                   ldx x_cursor_tr
                   ldy y_cursor_tr
                   clc
                   jsr plot
                   lda #"S"
                   jsr chrout
                   lda #" "
                   jsr chrout
                   rts
track_timer_paused = *
                   lda subchnl_track_number
                   jsr print_track

                   lda #157
                   jsr chrout
                   lda #157
                   jsr chrout
                   lda #"P"
                   jsr chrout
                   rts
track_timer_play   = *
                   lda subchnl_track_number
                   jsr print_track
track_timer_end    rts
;--------------------------------------
; Input A - byte       zachovava a,x,y)
;--------------------------------------
print_track        = *
                   sty pom_y
                   stx pom_x
                   sta pom_a

                   ldx x_cursor_tr
                   ldy y_cursor_tr
                   clc
                   jsr plot
               
                   ldx pom_a
                   lda #0
                   jsr print_num
                   lda #" "
                   jsr chrout
                   lda #" "
                   jsr chrout
                   lda #" "
                   jsr chrout

                   lda pom_a
                   ldx pom_x
                   ldy pom_y
                   rts
;--------------------------------------
test_command       = *
                          
                   jsr ioctl_CDROMRESET
                   
;                    inc $d020
; 
;                    lda #$00     ;Min
;                    sta $2001
;                    lda #$05     ;Sec
;                    sta $2002
;                    lda #$16
;                    sta $2003    ;Frame
;                    
;                    ldx #>$2000                  ;sector to read
;                    lda #>$3000
;                    jsr ioctl_CDROMREADDATA
;                    
;                    jsr ANALYZE_CDROM
; 
                    jmp main_loop
;--------------------------------------
player_head        = *
                   .byte 142,$0d
                   .text "uccccccccccccccccccccccccci",$0d
                   .text "bATAPI CD-ROM AUDIO PLAYERb",$0d
                   .text "b V0.04 BY VISAC (C) 1999 b",$0d
                   .text "jccccccccccccccccccccccccck",$0d
                   .text " TRACK: ",0
player_commands    = *
                   .text $0d,$0d," P - PLAY/PAUSE"
                   .text $0d," S - STOP"
                   .text $0d," E - EJECT"
                   .text $0d," C - CLOSE TRAY"
                   .text $0d," + - TRACK >>"
                   .text $0d," - - TRACK <<"
                   .text $0d," Q - QUIT",$0d,$0d
                   .byte 0
keyboard_rep       *=*+1
x_cursor_tr        *=*+1
y_cursor_tr        *=*+1
pom_x              *=*+1
pom_y              *=*+1
pom_a              *=*+1
timer0             *=*+1
timer1             *=*+1
track_my           *=*+1
;--------------------------------------
                   .include "atapi04.asm"

